#pragma once

#include <memory>
#include <agents.h>
#include "connect.h"

//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;
using namespace ::Concurrency::samples;


class input_agent : public agent
{
public:
    input_agent(){}

    ITarget<signal>* input_buffer()          {return &m_input;}
    ISource<signal>* output_buffer()         {return &m_output;}
    ISource<signal>* shutdown_output_buffer(){return &m_shutdown;}

private:
    void run();
    unbounded_buffer<signal>  m_input;
    unbounded_buffer<signal>  m_output;
    single_assignment<signal> m_shutdown;
};

inline void input_agent::run()
{
    //checkforinput determines if we exit
    while(checkforinput())
    {
        //wait for the message to input
        receive(m_input);

        //notify the output
        asend(m_output, signal());
    }

    //signal shutdown
    asend(m_shutdown, signal());
    this->done();
}