#pragma once

#include <memory>
#include <agents.h>
#include "connect.h"

//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;
using namespace ::Concurrency::samples;

class input_agent_dataflow : public agent
{
public:
    input_agent_dataflow();

    ITarget<signal>* input_buffer()           {return m_inputBuffer.get();}
    ISource<signal>* output_buffer()          {return &m_outputBuffer;}
    ISource<signal>* shutdown_output_buffer() {return &shutdown_buffer;}

private:
    void run();
    void input_check();

    typedef call<signal>                    CallBuffer;

    std::unique_ptr<CallBuffer>             m_inputBuffer;
    unbounded_buffer<signal>                m_outputBuffer;
    single_assignment<signal>               shutdown_buffer;
    volatile bool                           m_isActive;
}; 

inline input_agent_dataflow::input_agent_dataflow() : m_isActive (true)
{
    m_inputBuffer =  make_unique<CallBuffer>([this](signal){input_check();});
}

inline void input_agent_dataflow::input_check()
{
    //checkforinput determines if we exit
    if(checkforinput())
    {
        //either notify our output
        send(m_outputBuffer, signal());
    }
    else
    {
        //or signal shutdown
        send(shutdown_buffer,signal());
        this->done();
    }
}

inline void input_agent_dataflow::run()
{
}