#pragma once

#include <memory>
#include <agents.h>
#include "connect.h"

//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;
using namespace ::Concurrency::samples;

class render_agent : public agent
{
public:
    render_agent(){}
    ITarget<signal>* input_buffer()           {return &m_inputSignal;   }
    ISource<signal>* output_buffer()          {return &m_outputSignal;  }
    ITarget<signal>* shutdown_input_buffer()  {return &m_shutdownInput; }

private:
    void run()
    {
        //exit if we receive a message to shutdown
        signal canContinue;
        while(!try_receive(&m_shutdownInput, canContinue))
        {
            //wait for input
            receive(m_inputSignal);

            //call our work function
            render_app();

            //send a signal to the output
            asend(m_outputSignal,signal());
        }
        //signal shutdown
        this->done();
    }

    unbounded_buffer<signal>   m_inputSignal;
    unbounded_buffer<signal>   m_outputSignal;
    single_assignment<signal>  m_shutdownInput;
};