#pragma once

#include <memory>
#include <agents.h>
#include "connect.h"

//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;
using namespace ::Concurrency::samples;

class render_agent_dataflow : public agent
{

public:
    render_agent_dataflow();
    //public ports
    ITarget<signal>* input_buffer()            {return m_buffer.get();        }
    ISource<signal>* output_buffer()           {return m_buffer.get();        }
    ITarget<signal>* shutdown_input_buffer()   {return m_shutdown_buffer.get();}

private:
    void   run();
    signal render();
    void   shutdown();

    typedef transformer<signal, signal> RenderBuffer;
    typedef call<signal>                ShutdownBuffer;

    volatile bool                       m_isActive;
    std::unique_ptr<RenderBuffer>       m_buffer;
    std::unique_ptr<ShutdownBuffer>     m_shutdown_buffer;
};

render_agent_dataflow::render_agent_dataflow() : m_isActive (true)
{
    auto filterFunc   = [this](signal){return m_isActive;};
    auto renderFunc   = [this](signal){return this->render();};
    auto shutdownFunc = [this](signal){this->shutdown();};

    m_buffer = make_unique<RenderBuffer>(renderFunc, nullptr, filterFunc);
    m_shutdown_buffer = make_unique<ShutdownBuffer>(shutdownFunc);
}

signal render_agent_dataflow::render()
{
    render_app();
    return signal();
}

void render_agent_dataflow::shutdown()
{
    m_isActive = false;
    done();
}

void render_agent_dataflow::run()
{
}
