#pragma once

#include <memory>
#include <agents.h>
#include "connect.h"

//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;
using namespace ::Concurrency::samples;

class update_agent : public agent
{
public:
    update_agent(){}

    ITarget<signal>* input_buffer()          {return &m_inputBuffer;}
    ISource<signal>* output_buffer()         {return &m_outputBuffer;}
    ITarget<signal>* shutdown_input_buffer() {return &m_shutdownBuffer;}

private:
    void run()
    {
        //keep running until we get a shutdown message
        signal fCanContinue;
        while(!try_receive(&m_shutdownBuffer, fCanContinue))
        {
            //wait for a message on the input buffer
            receive(m_inputBuffer);

            //call update
            update_app_state();

            //send an output to any listening targets
            asend(m_outputBuffer,signal());
        }

        //set our status to done
        this->done();
    }

    unbounded_buffer<signal>    m_inputBuffer;
    unbounded_buffer<signal>    m_outputBuffer;
    single_assignment<signal>   m_shutdownBuffer;
};
