#pragma once

#include <memory>
#include <agents.h>
//note the implementation is entirely in a header file
//for demo purposes as is the global using directive
using namespace ::Concurrency;

class update_agent_dataflow : public agent
{
public:
    update_agent_dataflow();

    ITarget<signal>* input_buffer()          {return m_updateBuffer.get();  }
    ISource<signal>* output_buffer()         {return m_updateBuffer.get();  }
    ITarget<signal>* shutdown_input_buffer() {return m_shutdownBuffer.get();}

private:
    void   run();
    signal update();
    void   shutdown();

    typedef transformer<signal, signal> UpdateBuffer;
    typedef call<signal>                ShutdownBuffer;

    std::unique_ptr<UpdateBuffer>       m_updateBuffer;
    std::unique_ptr<ShutdownBuffer>     m_shutdownBuffer;
    volatile bool                       m_isActive;
};

update_agent_dataflow::update_agent_dataflow() :m_isActive (true)
{
    auto filterFunc   = [this](signal){return this->m_isActive;};
    auto updateFunc   = [this](signal){return this->update();};
    auto shutdownFunc = [this](signal){this->shutdown();};

    m_updateBuffer   = make_unique<UpdateBuffer>(updateFunc, nullptr, filterFunc);
    m_shutdownBuffer = make_unique<ShutdownBuffer>(shutdownFunc);
}

signal update_agent_dataflow::update()
{
    update_app_state();
    return signal();
}

void update_agent_dataflow::shutdown()
{
     //set our state to active and shutdown
    m_isActive = false;
    done();
}
void update_agent_dataflow::run()
{
}